//! \file bug3.cc

template <bool b, typename T = void>
struct Enable_If {};

template <typename T>
struct Enable_If<true, T> {
  typedef T type;
};

//! A basic template.
template <typename T>
struct Base {};

//! Specializations of Base depending on the OR of two parameters.
template <bool b1, bool b2, typename T>
struct Base<typename Enable_If<b1 || b2, T>::type> {};

//! Specializations of Base depending on the NOT of a parameter.
template <bool b1, bool b2, typename T>
struct Base<typename Enable_If<!b1, T>::type> {};
